// C++ includes used for precompiling -*- C++ -*-

// Copyright (C) 2003-2013 Free Software Foundation, Inc.
//
// This file is part of the GNU ISO C++ Library.  This library is free
// software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the
// Free Software Foundation; either version 3, or (at your option)
// any later version.

// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// Under Section 7 of GPL version 3, you are granted additional
// permissions described in the GCC Runtime Library Exception, version
// 3.1, as published by the Free Software Foundation.

// You should have received a copy of the GNU General Public License and
// a copy of the GCC Runtime Library Exception along with this program;
// see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
// <http://www.gnu.org/licenses/>.

/** @file stdc++.h
 *  This is an implementation file for a precompiled header.
 */

// 17.4.1.2 Headers

// C
#ifndef _GLIBCXX_NO_ASSERT
#include <cassert>
#endif
#include <cctype>
#include <cerrno>
#include <cfloat>
#include <ciso646>
#include <climits>
#include <clocale>
#include <cmath>
#include <csetjmp>
#include <csignal>
#include <cstdarg>
#include <cstddef>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>

#if __cplusplus >= 201103L
#include <ccomplex>
#include <cfenv>
#include <cinttypes>
#include <cstdalign>
#include <cstdbool>
#include <cstdint>
#include <ctgmath>
#include <cwchar>
#include <cwctype>
#endif

// C++
#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>

#if __cplusplus >= 201103L
#include <array>
#include <atomic>
#include <chrono>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>
#endif
#define rep(x,l,r) for(register ll x=l;x<=r;++x)
#define per(x,l,r) for(register ll x=l;x>=r;--x)
#define max(a,b) std::max(ll(a),ll(b))
#define min(a,b) std::min(ll(a),ll(b))
#define IO(x) freopen(#x".in","r",stdin),freopen(#x".out","w",stdout);
typedef long long ll;
ll readll(void){
	ll x=0,w=1;
	char c=getchar();
	for(;c<'0'||c>'9';c-'-'||(w=-w),c=getchar());
	for(;c>='0'&&c<='9';x=x*10+(c^48),c=getchar());
	return x*w;
}
//ll readllfst(void){
//	ll x=0,w=1;
//	char c=getchar();
//	for(;c<'0'||c>'9';c-'-'||(w=-w),c=gs());
//	for(;c>='0'&&c<='9';x=x*10+(c^48),c=getchar());
//	return x*w;
//}
char readchar(void){
	char c=getchar();
	for(;c==' ';c=getchar());
	return c;
}
//struct st{
//	char s[114514];
//	st(const char*){memcpy()}
//	operator char*(){return s;}
//	operator const char*()const{return s;}
//	st&operator=(st b){return s;}
//};
//void readst(char*s){
//	char c=getchar();
//	for(;c<'0'||c>'9';c-'-'||(w=-w),c=getchar());
//	for(;c>='0'&&c<='9';x=x*10+(c^48),c=getchar());
//	return x*w;
//}
ll ans[1145141],ls[1145141],rs[1145141],v[1145141],num[1145141],no_xm[1145141];
char f[1145141];
void dfs1(ll u,ll fa){
//	printf("%lld %lld\n",u,fa);
	if(!ls[u]){
		ans[u]=v[u];
		return;
	}
	if(ls[u])
	dfs1(ls[u],u);
	if(rs[u])
	dfs1(rs[u],u);
	switch(f[u]){
		case'!':ans[u]=!ans[ls[u]];
		break;
		case'&':ans[u]=ans[ls[u]]&ans[rs[u]];
		if(!ans[ls[u]])no_xm[rs[u]]=1;
		if(!ans[rs[u]])no_xm[ls[u]]=1;
		break;
		case'|':ans[u]=ans[ls[u]]|ans[rs[u]];
		if(ans[ls[u]])no_xm[rs[u]]=1;
		if(ans[rs[u]])no_xm[ls[u]]=1;
		break;
	}
}
void dfs2(ll u,ll fa){
	no_xm[u]+=no_xm[fa];
	if(ls[u])
	dfs2(ls[u],u);
	if(rs[u])
	dfs2(rs[u],u);
}
int main(){
//	printf("%.2lfMiB",(sizeof ans+sizeof ls+sizeof rs+sizeof v+sizeof num+sizeof no_xm+sizeof f)/1048576.0);
	IO(expr);
	char ch;
	ll top=0,cnt=1e5;
	while((ch=readchar())!='\n'){
//		printf("%c",ch);
		if(ch=='x'){
			num[++top]=readll();
		}
		else{
			f[++cnt]=ch;
			ls[cnt]=num[top];
			if(ch!='!')
			rs[cnt]=num[top-1],
			num[--top]=cnt;
			else
			num[top]=cnt;
		}
	}
	ll root=num[top];
//	printf("%lld\n",root);
	ll n=readll();
	rep(i,1,n)v[i]=readll();
	dfs1(root,0);
	dfs2(root,0);
	ll q=readll();
	rep(i,1,q){
		printf("%lld\n",ans[root]^!no_xm[readll()]);
	}
	return 0;
}
