#include <fstream>
#include <algorithm>
#include <iostream>

typedef long long ll;

ll map[1005][1005] = {0};
bool book[1005][1005] = {false};
ll max[1005][1005] = {0};

void dfs(ll x, ll y, ll n, ll m, ll sum)
{
	if(book[x][y])
	{
		return ;
	}
	if(sum + map[x][y] < max[x][y])
	{
		return ;
	}
	book[x][y] = true;
	max[x][y] = std::max(max[x][y], sum + map[x][y]);
	if(x == n && y == m)
	{
		book[x][y] = false;
		return ;
	}
	dfs(x + 1, y, n, m, sum + map[x][y]);
	dfs(x - 1, y, n, m, sum + map[x][y]);
	dfs(x, y + 1, n, m, sum + map[x][y]);
	book[x][y] = false;
}

int main(int argc, char** argv)
{
	std::ifstream cin("number.in");
	std::ofstream cout("number.out");
	
	ll n, m;
	cin >> n >> m;
	for(ll i = 1; i <= n; i++)
	{
		for(ll j = 1; j <= m; j++)
		{
			max[i][j] = -1e12;
			cin >> map[i][j];
		}
	}
	
	for(ll i = 0; i <= n + 1; i++)
	{
		book[i][0] = true;
		book[i][m + 1] = true;
	}
	
	for(ll i = 0; i <= m + 1; i++)
	{
		book[0][i] = true;
		book[n + 1][i] = true;
	}
	
	ll ans = -1e12;
	dfs(1, 1, n, m, 0);
	
	cout << max[n][m];
	
//	for(ll i = 1; i <= n; i++)
//	{
//		for(ll j = 1; j <= m; j++)
//		{
//			std::cout << max[i][j] << " ";
//		}
//		std::cout << "\n";
//	}
	
	cin.close();
	cout.close();
	return 0;
}
