#include "bits/stdc++.h"
using namespace std;
char expr_str[1000005];
int x_vars[100005];
int num_vars;

struct ExprNode {
    char node_type;
    int var_x;
    ExprNode *left;
    ExprNode *right;
    
    int eval() {
        if (this->node_type == 'x') {
            return x_vars[this->var_x];
        } else if (this->node_type == '!') {
            return !this->left->eval();
        } else if (this->node_type == '&') {
            return this->left->eval() && this->right->eval();
        } else if (this->node_type == '|') {
            return this->left->eval() || this->right->eval();
        }
        return 0;
    }
};

stack<ExprNode*> node_stack;
int main() {
    freopen("expr.in", "r", stdin);
    freopen("expr.out", "w", stdout);
    for (int i = 0;; i++) {
        scanf("%c", &expr_str[i]);
        if (expr_str[i] == '\n' || expr_str[i] == '\r') {
            break;
        }
    }
    int expr_len = strlen(expr_str);
    for (int i = 0; i < expr_len; i++) {
        if (expr_str[i] == 'x') {
            int var_index = 0;
            i++;
            while ('0' <= expr_str[i] && expr_str[i] <= '9') {
                var_index *= 10;
                var_index += expr_str[i] - '0';
                i++;
            }
            ExprNode *var_node = new ExprNode();
            var_node->node_type = 'x';
            var_node->var_x = var_index;
            node_stack.push(var_node);
        }
        if (expr_str[i] == '!') {
            ExprNode *not_node = new ExprNode();
            not_node->node_type = '!';
            not_node->left = node_stack.top();
            node_stack.pop();
            node_stack.push(not_node);
        }
        if (expr_str[i] == '&' || expr_str[i] == '|') {
            ExprNode *bin_node = new ExprNode();
            bin_node->node_type = expr_str[i];
            bin_node->right = node_stack.top();
            node_stack.pop();
            bin_node->left = node_stack.top();
            node_stack.pop();
            node_stack.push(bin_node);
        }
    }
    ExprNode *expr_root = node_stack.top();
    
    scanf("%d", &num_vars);
    for (int i = 1; i <= num_vars; i++) {
        scanf("%d", &x_vars[i]);
    }
    
    int num_questions;
    scanf("%d", &num_questions);
    for (int i = 0; i < num_questions; i++) {
        int var_index;
        scanf("%d", &var_index);
        x_vars[var_index] = !x_vars[var_index];
        printf("%d\n", expr_root->eval());
        x_vars[var_index] = !x_vars[var_index];
    }
    
    return 0;
}

