#include <fstream>
#include <string>
//#define IO_IN_CONSOLE
#ifdef IO_IN_CONSOLE
#define IN_FILE "CON"
#define OUT_FILE "CON"
#else
#define IN_FILE "expr.in"
#define OUT_FILE "expr.out"
#endif
using namespace std;
#define OPERATOR_NULL 0
#define OPERATOR_AND 1
#define OPERATOR_OR 2
#define OPERATOR_NOT 3
typedef struct _Node {
	int nOperator;
	bool bReverseTag;
	bool bValue;
	_Node* ptnFather,*ptnChildL,*ptnChildR;
} Node,*lpNode;
Node tnTree[100001];
Node tnLeaf[100001];
lpNode ptnStack[200001]= {NULL};
int nElCnt=-1;
lpNode ptnHead=NULL;
int nNodeCnt=0;
int nLeafCnt=0;
string sExpression;
int nExprLen;
void fvCreate(int nAt) {
	while(nAt<nExprLen) {
		if(sExpression[nAt]==' ') {
			nAt++;
			continue;
		}
		if(sExpression[nAt]=='x') {
			nAt++;
			int nID=0;
			while(nAt<nExprLen&&sExpression[nAt]!=' ') {
				nID*=10;
				nID+=sExpression[nAt]-'0';
				nAt++;
			}
			tnLeaf[nID].bReverseTag=false;
			tnLeaf[nID].nOperator=OPERATOR_NULL;
			tnLeaf[nID].ptnChildL=NULL;
			tnLeaf[nID].ptnChildR=NULL;
			tnLeaf[nID].ptnFather=NULL;
			ptnStack[++nElCnt]=(&tnLeaf[nID]);
			continue;
		}
		if(sExpression[nAt]=='!') {
			ptnStack[nElCnt]->bReverseTag=!ptnStack[nElCnt]->bReverseTag;
			nAt++;
			continue;
		}
		if(sExpression[nAt]=='&') {
			tnTree[nNodeCnt].bReverseTag=false;
			tnTree[nNodeCnt].nOperator=OPERATOR_AND;
			tnTree[nNodeCnt].ptnFather=NULL;
			tnTree[nNodeCnt].ptnChildR=ptnStack[nElCnt];
			ptnStack[nElCnt--]->ptnFather=&tnTree[nNodeCnt];
			tnTree[nNodeCnt].ptnChildL=ptnStack[nElCnt];
			ptnStack[nElCnt--]->ptnFather=&tnTree[nNodeCnt];
			ptnStack[++nElCnt]=(&tnTree[nNodeCnt++]);
			nAt++;
			continue;
		}
		if(sExpression[nAt]=='|') {
			tnTree[nNodeCnt].bReverseTag=false;
			tnTree[nNodeCnt].nOperator=OPERATOR_OR;
			tnTree[nNodeCnt].ptnFather=NULL;
			tnTree[nNodeCnt].ptnChildR=ptnStack[nElCnt];
			ptnStack[nElCnt--]->ptnFather=&tnTree[nNodeCnt];
			tnTree[nNodeCnt].ptnChildL=ptnStack[nElCnt];
			ptnStack[nElCnt--]->ptnFather=&tnTree[nNodeCnt];
			ptnStack[++nElCnt]=(&tnTree[nNodeCnt++]);
			nAt++;
			continue;
		}
	}
	ptnHead=ptnStack[0];
}
bool fbInitialize(lpNode ptnCurNode) {
	if(ptnCurNode->nOperator==OPERATOR_NULL) {
		if(ptnCurNode->bReverseTag) {
			return !ptnCurNode->bValue;
		}
		return ptnCurNode->bValue;
	}
	if(ptnCurNode->nOperator==OPERATOR_AND) {
		ptnCurNode->bValue=fbInitialize(ptnCurNode->ptnChildL)&fbInitialize(ptnCurNode->ptnChildR);
		if(ptnCurNode->bReverseTag) {
			return !ptnCurNode->bValue;
		}
		return ptnCurNode->bValue;
	}
	if(ptnCurNode->nOperator==OPERATOR_OR) {
		ptnCurNode->bValue=fbInitialize(ptnCurNode->ptnChildL)|fbInitialize(ptnCurNode->ptnChildR);
		if(ptnCurNode->bReverseTag) {
			return !ptnCurNode->bValue;
		}
		return ptnCurNode->bValue;
	}
	return false;
}
bool fbCalcChange(lpNode ptnCurNode) {
	if(ptnCurNode->ptnFather==NULL) {
		if(ptnCurNode->nOperator==OPERATOR_NULL) {
			return false;
		}
		bool bValL,bValR;
		bValL=(ptnCurNode->ptnChildL->bReverseTag)? (!ptnCurNode->ptnChildL->bValue):(ptnCurNode->ptnChildL->bValue);
		bValR=(ptnCurNode->ptnChildR->bReverseTag)? (!ptnCurNode->ptnChildR->bValue):(ptnCurNode->ptnChildR->bValue);
		bool bResult=false;
		if(ptnCurNode->nOperator==OPERATOR_AND) {
			bResult=bValL&bValR;
		}
		if(ptnCurNode->nOperator==OPERATOR_OR) {
			bResult=bValL|bValR;
		}
		return ptnCurNode->bReverseTag? !bResult:bResult;
	}
	if(ptnCurNode->nOperator==OPERATOR_NULL) {
		return fbCalcChange(ptnCurNode->ptnFather);
	}
	bool bValL,bValR;
	bValL=(ptnCurNode->ptnChildL->bReverseTag)? (!ptnCurNode->ptnChildL->bValue):(ptnCurNode->ptnChildL->bValue);
	bValR=(ptnCurNode->ptnChildR->bReverseTag)? (!ptnCurNode->ptnChildR->bValue):(ptnCurNode->ptnChildR->bValue);
	bool bResult=false;
	if(ptnCurNode->nOperator==OPERATOR_AND) {
		bResult=bValL&bValR;
	}
	if(ptnCurNode->nOperator==OPERATOR_OR) {
		bResult=bValL|bValR;
	}
	if(bResult==ptnCurNode->bValue){
		return ptnHead->bValue;
	}
	bool bOriginal=ptnCurNode->bValue;
	ptnCurNode->bValue=bResult;
	bResult=fbCalcChange(ptnCurNode->ptnFather);
	ptnCurNode->bValue=bOriginal;
	return bResult;
}
int main(void) {
	ifstream input(IN_FILE);
	ofstream output(OUT_FILE);
	getline(input,sExpression);
	nExprLen=sExpression.length();
	input>>nLeafCnt;
	fvCreate(0);
	for(int i=1; i<=nLeafCnt; i++) {
		bool nParaIn;
		input>>nParaIn;
		tnLeaf[i].bValue=nParaIn;
	}
	fbInitialize(ptnHead);
	int nQueryCnt;
	input>>nQueryCnt;
	for(int i=0;i<nQueryCnt;i++){
		int nChangeID;
		input>>nChangeID;
		tnLeaf[nChangeID].bValue=!tnLeaf[nChangeID].bValue;
		output<<fbCalcChange(&tnLeaf[nChangeID])<<endl;
		tnLeaf[nChangeID].bValue=!tnLeaf[nChangeID].bValue;
	}
	return 0;
}
