#include <iostream>
#include <cstdio>
#include <sstream>
#include <string>

using namespace std;

struct T {
	char op = '\0';
	int lc = 0, rc = 0;
	int fa = 0;
	bool val;
} tr[1000010];
bool vs[100010];
int pos[100010];
int n, q, t1;
struct Stack {
	int st[1000010];
	int tp = 0;
	void push(int x) {
		st[++tp] = x;
	}
	int top() {
		return st[tp];
	}
	void pop() {
		tp--;
	}
	bool empty() {
		return tp == 0;
	}
} as;
string s, tmp;

int s2i(string s) {
	int res = 0;
	int l = s.length();
	for (int i = 0; i < l; i++)
		res = res*10+s[i]-'0';
	return res;
}

int node(char op, int lc, int rc, int fa, bool val) {
	++t1;
	tr[t1].op = op;
	tr[t1].lc = lc;
	tr[t1].rc = rc;
	tr[t1].fa = fa;
	tr[t1].val = val;
	return t1;
}

int dfs(int x, bool sum) {
	int fa = tr[x].fa;
	if (tr[fa].op == '&') {
		if (tr[fa].lc == x)
			return dfs(fa, sum&tr[tr[fa].rc].val);
		else
			return dfs(fa, sum&tr[tr[fa].lc].val);
	}
	else if (tr[fa].op == '|') {
		if (tr[fa].lc == x)
			return dfs(fa, sum|tr[tr[fa].rc].val);
		else
			return dfs(fa, sum|tr[tr[fa].lc].val);
	}
	else if (tr[fa].op == '!') {
		return dfs(fa, !sum);
	}
	else
		return sum;
}

int main() {
	freopen("expr.in", "r", stdin);
	freopen("expr.out", "w", stdout);
	getline(cin, s);
	stringstream ss(s);
	scanf("%d", &n);
	for (int i = 1; i <= n; i++) {
		scanf("%d", &vs[i]);
	}
	while (ss >> tmp) {
		if (tmp.length() == 1) {
			if (tmp[0] == '!') {
				int lc = as.top(); as.pop();
				if (tr[lc].op != '!') {
					int nnd = node('!', lc, 0, 0, !tr[lc].val);
					tr[lc].fa = nnd;
					as.push(nnd);
				}
				else {
					tr[tr[lc].lc].fa = 0;
					as.push(tr[lc].lc);
					t1--;
				}
			}
			else if (tmp[0] == '&') {
				int rc = as.top(); as.pop();
				int lc = as.top(); as.pop();
				int nnd = node('&', lc, rc, 0, tr[rc].val&tr[lc].val);
				tr[rc].fa = tr[lc].fa = nnd;
				as.push(nnd);
			}
			else {
				int rc = as.top(); as.pop();
				int lc = as.top(); as.pop();
				int nnd = node('|', lc, rc, 0, tr[rc].val|tr[lc].val);
				tr[rc].fa = tr[lc].fa = nnd;
				as.push(nnd);
			}
		}
		else {
			int i = s2i(tmp.substr(1));
			int nnd = node('\0', 0, 0, 0, vs[i]);
			pos[i] = nnd;
			as.push(nnd);
		}
	}
	scanf("%d", &q);
	int x;
	for (int i = 1; i <= q; i++) {
		scanf("%d", &x);
		tr[pos[x]].val = !tr[pos[x]].val;
		int ans = dfs(pos[x], tr[pos[x]].val);
		tr[pos[x]].val = !tr[pos[x]].val;
		printf("%d\n", ans);
	}
	return 0;
}
