/*
 *	Macesuted Kysic
 *	Nov. 7th
 *
 *	100 pts
 *	O(nmlgn)
 */

#include <bits/stdc++.h>
using namespace std;

template <typename T>
T read(void)
{
	T f=1,num=0;
	char c=getchar();
	while(c<'0'||c>'9') 
	{
		if(c=='-') f=-f;
		c=getchar();
	}
	while(c>='0'&&c<='9')
	{
		num=(num<<3)+(num<<1)+(c^48);
		c=getchar();
	}
	return f*num;
}

const int maxn=1005;

int matrix[maxn][maxn],sum[maxn],f[maxn];

int tree[maxn<<2],lazy[maxn<<2];
void pushDown(int p)
{
	if(!lazy[p]) return;
	tree[p<<1]+=lazy[p],tree[p<<1|1]+=lazy[p];
	lazy[p<<1]+=lazy[p],lazy[p<<1|1]+=lazy[p],lazy[p]=0;
	return;
}
void build(int p,int l,int r)
{
	if(l==r) return lazy[p]=0,void(tree[p]=sum[l]);
	pushDown(p);
	int mid=(l+r)>>1;
	build(p<<1,l,mid),build(p<<1|1,mid+1,r);
	tree[p]=max(tree[p<<1],tree[p<<1|1]),lazy[p]=0;
	return;
}
void add(int p,int l,int r,int ql,int qr,int delta)
{
	if(ql<=l&&r<=qr) return tree[p]+=delta,void(lazy[p]+=delta);
	pushDown(p);
	int mid=(l+r)>>1;
	if(ql<=mid) add(p<<1,l,mid,ql,qr,delta);
	if(qr>mid) add(p<<1|1,mid+1,r,ql,qr,delta);
	tree[p]=max(tree[p<<1],tree[p<<1|1]);
	return;
}

int main()
{
	freopen("number.in","r",stdin),freopen("number.out","w",stdout);
	int n=read<int>(),m=read<int>();
	for(register int i=1;i<=n;i++)
		for(register int j=1;j<=m;j++)
			matrix[i][j]=read<int>();
	for(register int i=1,s=0;i<=n;i++) s+=matrix[i][1],f[i]=s;
	for(register int j=2;j<=m;j++)
	{
		for(register int i=1,s=0;i<=n;i++) s+=matrix[i][j],sum[i]=f[i]+s;
		build(1,1,n);
		f[1]=tree[1];
		for(register int i=2;i<=n;i++)
		{
			add(1,1,n,1,i-1,matrix[i][j]),add(1,1,n,i,n,-matrix[i-1][j]);
			f[i]=tree[1];
		}
	}
	printf("%d\n",f[n]);
	return 0;
}
